/* xnoise-playlist-entry.c generated by valac, the Vala compiler
 * generated from xnoise-playlist-entry.vala, do not modify */

/* pl-item.vala
 *
 * Copyright (C) 2010  Jörn Magens
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The Xnoise authors hereby grant permission for non-GPL compatible
 *  GStreamer plugins to be used and distributed together with GStreamer
 *  and Xnoise. This permission is above and beyond the permissions granted
 *  by the GPL license by which Xnoise is covered. If you modify this code
 *  you may extend this exception to your version of the code, but you are not
 *  obligated to do so. If you do not wish to do so, delete this exception
 *  statement from your version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author:
 *     Jörn Magens <shuerhaaken@googlemail.com>
 */
/* an instance of this Entry object represents one entry in the list. An entry contains one or more data fields, at least the uri to the target*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define XNOISE_PLAYLIST_TYPE_ENTRY (xnoise_playlist_entry_get_type ())
#define XNOISE_PLAYLIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_PLAYLIST_TYPE_ENTRY, XnoisePlaylistEntry))
#define XNOISE_PLAYLIST_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_PLAYLIST_TYPE_ENTRY, XnoisePlaylistEntryClass))
#define XNOISE_PLAYLIST_IS_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_PLAYLIST_TYPE_ENTRY))
#define XNOISE_PLAYLIST_IS_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_PLAYLIST_TYPE_ENTRY))
#define XNOISE_PLAYLIST_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_PLAYLIST_TYPE_ENTRY, XnoisePlaylistEntryClass))

typedef struct _XnoisePlaylistEntry XnoisePlaylistEntry;
typedef struct _XnoisePlaylistEntryClass XnoisePlaylistEntryClass;
typedef struct _XnoisePlaylistEntryPrivate XnoisePlaylistEntryPrivate;

#define XNOISE_PLAYLIST_ENTRY_TYPE_FIELD (xnoise_playlist_entry_field_get_type ())

#define XNOISE_PLAYLIST_TYPE_TARGET_TYPE (xnoise_playlist_target_type_get_type ())
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _XnoisePlaylistParamSpecEntry XnoisePlaylistParamSpecEntry;

struct _XnoisePlaylistEntry {
	GTypeInstance parent_instance;
	volatile int ref_count;
	XnoisePlaylistEntryPrivate * priv;
};

struct _XnoisePlaylistEntryClass {
	GTypeClass parent_class;
	void (*finalize) (XnoisePlaylistEntry *self);
};

typedef enum  {
	XNOISE_PLAYLIST_ENTRY_FIELD_URI = 0,
	XNOISE_PLAYLIST_ENTRY_FIELD_TITLE,
	XNOISE_PLAYLIST_ENTRY_FIELD_AUTHOR,
	XNOISE_PLAYLIST_ENTRY_FIELD_GENRE,
	XNOISE_PLAYLIST_ENTRY_FIELD_ALBUM,
	XNOISE_PLAYLIST_ENTRY_FIELD_COPYRIGHT,
	XNOISE_PLAYLIST_ENTRY_FIELD_DURATION,
	XNOISE_PLAYLIST_ENTRY_FIELD_PARAM_NAME,
	XNOISE_PLAYLIST_ENTRY_FIELD_PARAM_VALUE,
	XNOISE_PLAYLIST_ENTRY_FIELD_IS_REMOTE,
	XNOISE_PLAYLIST_ENTRY_FIELD_IS_PLAYLIST
} XnoisePlaylistEntryField;

typedef enum  {
	XNOISE_PLAYLIST_TARGET_TYPE_URI,
	XNOISE_PLAYLIST_TARGET_TYPE_REL_PATH,
	XNOISE_PLAYLIST_TARGET_TYPE_ABS_PATH
} XnoisePlaylistTargetType;

struct _XnoisePlaylistEntryPrivate {
	GHashTable* htable;
	XnoisePlaylistTargetType _target_type;
	gchar* _base_path;
};

struct _XnoisePlaylistParamSpecEntry {
	GParamSpec parent_instance;
};


static gpointer xnoise_playlist_entry_parent_class = NULL;

gpointer xnoise_playlist_entry_ref (gpointer instance);
void xnoise_playlist_entry_unref (gpointer instance);
GParamSpec* xnoise_playlist_param_spec_entry (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void xnoise_playlist_value_set_entry (GValue* value, gpointer v_object);
void xnoise_playlist_value_take_entry (GValue* value, gpointer v_object);
gpointer xnoise_playlist_value_get_entry (const GValue* value);
GType xnoise_playlist_entry_get_type (void) G_GNUC_CONST;
GType xnoise_playlist_entry_field_get_type (void) G_GNUC_CONST;
GType xnoise_playlist_target_type_get_type (void) G_GNUC_CONST;
#define XNOISE_PLAYLIST_ENTRY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), XNOISE_PLAYLIST_TYPE_ENTRY, XnoisePlaylistEntryPrivate))
enum  {
	XNOISE_PLAYLIST_ENTRY_DUMMY_PROPERTY
};
XnoisePlaylistEntry* xnoise_playlist_entry_new (void);
XnoisePlaylistEntry* xnoise_playlist_entry_construct (GType object_type);
static void _g_free0_ (gpointer var);
void xnoise_playlist_entry_add_field (XnoisePlaylistEntry* self, XnoisePlaylistEntryField field, const gchar* val);
XnoisePlaylistEntryField* xnoise_playlist_entry_get_contained_fields (XnoisePlaylistEntry* self, int* result_length1);
static void _vala_array_add104 (XnoisePlaylistEntryField** array, int* length, int* size, XnoisePlaylistEntryField value);
gchar* xnoise_playlist_entry_get_field (XnoisePlaylistEntry* self, XnoisePlaylistEntryField field);
gchar* xnoise_playlist_entry_get_uri (XnoisePlaylistEntry* self);
gchar* xnoise_playlist_entry_get_rel_path (XnoisePlaylistEntry* self);
const gchar* xnoise_playlist_entry_get_base_path (XnoisePlaylistEntry* self);
gchar* xnoise_playlist_entry_get_abs_path (XnoisePlaylistEntry* self);
static gboolean _vala_string_array_contains (const gchar** stack, int stack_length, const gchar* needle);
gchar* xnoise_playlist_entry_get_title (XnoisePlaylistEntry* self);
gchar* xnoise_playlist_entry_get_author (XnoisePlaylistEntry* self);
gchar* xnoise_playlist_entry_get_genre (XnoisePlaylistEntry* self);
gchar* xnoise_playlist_entry_get_album (XnoisePlaylistEntry* self);
gchar* xnoise_playlist_entry_get_copyright (XnoisePlaylistEntry* self);
gchar* xnoise_playlist_entry_get_duration_string (XnoisePlaylistEntry* self);
gchar* xnoise_playlist_entry_get_param_name (XnoisePlaylistEntry* self);
gchar* xnoise_playlist_entry_get_param_value (XnoisePlaylistEntry* self);
glong xnoise_playlist_entry_get_duration (XnoisePlaylistEntry* self);
glong xnoise_playlist_get_duration_from_string (gchar** duration_string);
gboolean xnoise_playlist_entry_is_remote (XnoisePlaylistEntry* self);
gboolean xnoise_playlist_entry_is_playlist (XnoisePlaylistEntry* self);
XnoisePlaylistTargetType xnoise_playlist_entry_get_target_type (XnoisePlaylistEntry* self);
void xnoise_playlist_entry_set_target_type (XnoisePlaylistEntry* self, XnoisePlaylistTargetType value);
void xnoise_playlist_entry_set_base_path (XnoisePlaylistEntry* self, const gchar* value);
static void xnoise_playlist_entry_finalize (XnoisePlaylistEntry* obj);

extern const gchar* XNOISE_PLAYLIST_remote_schemes[3];

GType xnoise_playlist_entry_field_get_type (void) {
	static volatile gsize xnoise_playlist_entry_field_type_id__volatile = 0;
	if (g_once_init_enter (&xnoise_playlist_entry_field_type_id__volatile)) {
		static const GEnumValue values[] = {{XNOISE_PLAYLIST_ENTRY_FIELD_URI, "XNOISE_PLAYLIST_ENTRY_FIELD_URI", "uri"}, {XNOISE_PLAYLIST_ENTRY_FIELD_TITLE, "XNOISE_PLAYLIST_ENTRY_FIELD_TITLE", "title"}, {XNOISE_PLAYLIST_ENTRY_FIELD_AUTHOR, "XNOISE_PLAYLIST_ENTRY_FIELD_AUTHOR", "author"}, {XNOISE_PLAYLIST_ENTRY_FIELD_GENRE, "XNOISE_PLAYLIST_ENTRY_FIELD_GENRE", "genre"}, {XNOISE_PLAYLIST_ENTRY_FIELD_ALBUM, "XNOISE_PLAYLIST_ENTRY_FIELD_ALBUM", "album"}, {XNOISE_PLAYLIST_ENTRY_FIELD_COPYRIGHT, "XNOISE_PLAYLIST_ENTRY_FIELD_COPYRIGHT", "copyright"}, {XNOISE_PLAYLIST_ENTRY_FIELD_DURATION, "XNOISE_PLAYLIST_ENTRY_FIELD_DURATION", "duration"}, {XNOISE_PLAYLIST_ENTRY_FIELD_PARAM_NAME, "XNOISE_PLAYLIST_ENTRY_FIELD_PARAM_NAME", "param-name"}, {XNOISE_PLAYLIST_ENTRY_FIELD_PARAM_VALUE, "XNOISE_PLAYLIST_ENTRY_FIELD_PARAM_VALUE", "param-value"}, {XNOISE_PLAYLIST_ENTRY_FIELD_IS_REMOTE, "XNOISE_PLAYLIST_ENTRY_FIELD_IS_REMOTE", "is-remote"}, {XNOISE_PLAYLIST_ENTRY_FIELD_IS_PLAYLIST, "XNOISE_PLAYLIST_ENTRY_FIELD_IS_PLAYLIST", "is-playlist"}, {0, NULL, NULL}};
		GType xnoise_playlist_entry_field_type_id;
		xnoise_playlist_entry_field_type_id = g_enum_register_static ("XnoisePlaylistEntryField", values);
		g_once_init_leave (&xnoise_playlist_entry_field_type_id__volatile, xnoise_playlist_entry_field_type_id);
	}
	return xnoise_playlist_entry_field_type_id__volatile;
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


XnoisePlaylistEntry* xnoise_playlist_entry_construct (GType object_type) {
	XnoisePlaylistEntry* self = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	self = (XnoisePlaylistEntry*) g_type_create_instance (object_type);
	_tmp0_ = g_direct_hash;
	_tmp1_ = g_direct_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, NULL, _g_free0_);
	_g_hash_table_unref0 (self->priv->htable);
	self->priv->htable = _tmp2_;
	return self;
}


XnoisePlaylistEntry* xnoise_playlist_entry_new (void) {
	return xnoise_playlist_entry_construct (XNOISE_PLAYLIST_TYPE_ENTRY);
}


void xnoise_playlist_entry_add_field (XnoisePlaylistEntry* self, XnoisePlaylistEntryField field, const gchar* val) {
	GHashTable* _tmp0_;
	XnoisePlaylistEntryField _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	g_return_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self));
	g_return_if_fail (val != NULL);
	_tmp0_ = self->priv->htable;
	_tmp1_ = field;
	_tmp2_ = val;
	_tmp3_ = g_strdup (_tmp2_);
	g_hash_table_insert (_tmp0_, (gpointer) ((gintptr) _tmp1_), _tmp3_);
}


static void _vala_array_add104 (XnoisePlaylistEntryField** array, int* length, int* size, XnoisePlaylistEntryField value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoisePlaylistEntryField, *array, *size);
	}
	(*array)[(*length)++] = value;
}


XnoisePlaylistEntryField* xnoise_playlist_entry_get_contained_fields (XnoisePlaylistEntry* self, int* result_length1) {
	XnoisePlaylistEntryField* result = NULL;
	XnoisePlaylistEntryField* _tmp0_ = NULL;
	XnoisePlaylistEntryField* retval;
	gint retval_length1;
	gint _retval_size_;
	GHashTable* _tmp1_;
	GList* _tmp2_ = NULL;
	GList* list;
	GList* _tmp3_;
	GList* _tmp5_;
	XnoisePlaylistEntryField* _tmp8_;
	gint _tmp8__length1;
	g_return_val_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self), NULL);
	_tmp0_ = g_new0 (XnoisePlaylistEntryField, 0);
	retval = _tmp0_;
	retval_length1 = 0;
	_retval_size_ = retval_length1;
	_tmp1_ = self->priv->htable;
	_tmp2_ = g_hash_table_get_keys (_tmp1_);
	list = _tmp2_;
	_tmp3_ = list;
	if (_tmp3_ == NULL) {
		XnoisePlaylistEntryField* _tmp4_;
		gint _tmp4__length1;
		_tmp4_ = retval;
		_tmp4__length1 = retval_length1;
		if (result_length1) {
			*result_length1 = _tmp4__length1;
		}
		result = _tmp4_;
		_g_list_free0 (list);
		return result;
	}
	_tmp5_ = list;
	{
		GList* f_collection = NULL;
		GList* f_it = NULL;
		f_collection = _tmp5_;
		for (f_it = f_collection; f_it != NULL; f_it = f_it->next) {
			XnoisePlaylistEntryField f = 0;
			f = (XnoisePlaylistEntryField) ((gintptr) f_it->data);
			{
				XnoisePlaylistEntryField* _tmp6_;
				gint _tmp6__length1;
				XnoisePlaylistEntryField _tmp7_;
				_tmp6_ = retval;
				_tmp6__length1 = retval_length1;
				_tmp7_ = f;
				_vala_array_add104 (&retval, &retval_length1, &_retval_size_, _tmp7_);
			}
		}
	}
	_tmp8_ = retval;
	_tmp8__length1 = retval_length1;
	if (result_length1) {
		*result_length1 = _tmp8__length1;
	}
	result = _tmp8_;
	_g_list_free0 (list);
	return result;
}


gchar* xnoise_playlist_entry_get_field (XnoisePlaylistEntry* self, XnoisePlaylistEntryField field) {
	gchar* result = NULL;
	GHashTable* _tmp0_;
	XnoisePlaylistEntryField _tmp1_;
	gconstpointer _tmp2_ = NULL;
	gchar* _tmp3_;
	g_return_val_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self), NULL);
	_tmp0_ = self->priv->htable;
	_tmp1_ = field;
	_tmp2_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) _tmp1_));
	_tmp3_ = g_strdup ((const gchar*) _tmp2_);
	result = _tmp3_;
	return result;
}


gchar* xnoise_playlist_entry_get_uri (XnoisePlaylistEntry* self) {
	gchar* result = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_ = NULL;
	gchar* _tmp2_;
	g_return_val_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self), NULL);
	_tmp0_ = self->priv->htable;
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) XNOISE_PLAYLIST_ENTRY_FIELD_URI));
	_tmp2_ = g_strdup ((const gchar*) _tmp1_);
	result = _tmp2_;
	return result;
}


gchar* xnoise_playlist_entry_get_rel_path (XnoisePlaylistEntry* self) {
	gchar* result = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* s;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GFile* _tmp5_ = NULL;
	GFile* f;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	GFile* _tmp8_ = NULL;
	GFile* bp;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	gchar* _tmp12_ = NULL;
	g_return_val_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self), NULL);
	_tmp0_ = self->priv->htable;
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) XNOISE_PLAYLIST_ENTRY_FIELD_URI));
	_tmp2_ = g_strdup ((const gchar*) _tmp1_);
	s = _tmp2_;
	_tmp3_ = s;
	if (_tmp3_ == NULL) {
		result = NULL;
		_g_free0 (s);
		return result;
	}
	_tmp4_ = s;
	_tmp5_ = g_file_new_for_uri (_tmp4_);
	f = _tmp5_;
	_tmp6_ = self->priv->_base_path;
	if (_tmp6_ == NULL) {
		result = NULL;
		_g_object_unref0 (f);
		_g_free0 (s);
		return result;
	}
	_tmp7_ = self->priv->_base_path;
	_tmp8_ = g_file_new_for_path (_tmp7_);
	bp = _tmp8_;
	_tmp9_ = bp;
	if (_tmp9_ == NULL) {
		result = NULL;
		_g_object_unref0 (bp);
		_g_object_unref0 (f);
		_g_free0 (s);
		return result;
	}
	_tmp10_ = bp;
	_tmp11_ = f;
	_tmp12_ = g_file_get_relative_path (_tmp10_, _tmp11_);
	result = _tmp12_;
	_g_object_unref0 (bp);
	_g_object_unref0 (f);
	_g_free0 (s);
	return result;
}


static gboolean _vala_string_array_contains (const gchar** stack, int stack_length, const gchar* needle) {
	int i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}


gchar* xnoise_playlist_entry_get_abs_path (XnoisePlaylistEntry* self) {
	gchar* result = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* s;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GFile* _tmp5_ = NULL;
	GFile* f;
	GFile* _tmp6_;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_;
	gboolean _tmp9_;
	GFile* _tmp10_;
	gchar* _tmp11_ = NULL;
	g_return_val_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self), NULL);
	_tmp0_ = self->priv->htable;
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) XNOISE_PLAYLIST_ENTRY_FIELD_URI));
	_tmp2_ = g_strdup ((const gchar*) _tmp1_);
	s = _tmp2_;
	_tmp3_ = s;
	if (_tmp3_ == NULL) {
		result = NULL;
		_g_free0 (s);
		return result;
	}
	_tmp4_ = s;
	_tmp5_ = g_file_new_for_uri (_tmp4_);
	f = _tmp5_;
	_tmp6_ = f;
	_tmp7_ = g_file_get_uri_scheme (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = _vala_string_array_contains (XNOISE_PLAYLIST_remote_schemes, G_N_ELEMENTS (XNOISE_PLAYLIST_remote_schemes), _tmp8_);
	_g_free0 (_tmp8_);
	if (_tmp9_) {
		result = NULL;
		_g_object_unref0 (f);
		_g_free0 (s);
		return result;
	}
	_tmp10_ = f;
	_tmp11_ = g_file_get_path (_tmp10_);
	result = _tmp11_;
	_g_object_unref0 (f);
	_g_free0 (s);
	return result;
}


gchar* xnoise_playlist_entry_get_title (XnoisePlaylistEntry* self) {
	gchar* result = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_ = NULL;
	gchar* _tmp2_;
	g_return_val_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self), NULL);
	_tmp0_ = self->priv->htable;
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) XNOISE_PLAYLIST_ENTRY_FIELD_TITLE));
	_tmp2_ = g_strdup ((const gchar*) _tmp1_);
	result = _tmp2_;
	return result;
}


gchar* xnoise_playlist_entry_get_author (XnoisePlaylistEntry* self) {
	gchar* result = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_ = NULL;
	gchar* _tmp2_;
	g_return_val_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self), NULL);
	_tmp0_ = self->priv->htable;
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) XNOISE_PLAYLIST_ENTRY_FIELD_AUTHOR));
	_tmp2_ = g_strdup ((const gchar*) _tmp1_);
	result = _tmp2_;
	return result;
}


gchar* xnoise_playlist_entry_get_genre (XnoisePlaylistEntry* self) {
	gchar* result = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_ = NULL;
	gchar* _tmp2_;
	g_return_val_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self), NULL);
	_tmp0_ = self->priv->htable;
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) XNOISE_PLAYLIST_ENTRY_FIELD_GENRE));
	_tmp2_ = g_strdup ((const gchar*) _tmp1_);
	result = _tmp2_;
	return result;
}


gchar* xnoise_playlist_entry_get_album (XnoisePlaylistEntry* self) {
	gchar* result = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_ = NULL;
	gchar* _tmp2_;
	g_return_val_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self), NULL);
	_tmp0_ = self->priv->htable;
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) XNOISE_PLAYLIST_ENTRY_FIELD_ALBUM));
	_tmp2_ = g_strdup ((const gchar*) _tmp1_);
	result = _tmp2_;
	return result;
}


gchar* xnoise_playlist_entry_get_copyright (XnoisePlaylistEntry* self) {
	gchar* result = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_ = NULL;
	gchar* _tmp2_;
	g_return_val_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self), NULL);
	_tmp0_ = self->priv->htable;
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) XNOISE_PLAYLIST_ENTRY_FIELD_COPYRIGHT));
	_tmp2_ = g_strdup ((const gchar*) _tmp1_);
	result = _tmp2_;
	return result;
}


gchar* xnoise_playlist_entry_get_duration_string (XnoisePlaylistEntry* self) {
	gchar* result = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_ = NULL;
	gchar* _tmp2_;
	g_return_val_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self), NULL);
	_tmp0_ = self->priv->htable;
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) XNOISE_PLAYLIST_ENTRY_FIELD_DURATION));
	_tmp2_ = g_strdup ((const gchar*) _tmp1_);
	result = _tmp2_;
	return result;
}


gchar* xnoise_playlist_entry_get_param_name (XnoisePlaylistEntry* self) {
	gchar* result = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_ = NULL;
	gchar* _tmp2_;
	g_return_val_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self), NULL);
	_tmp0_ = self->priv->htable;
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) XNOISE_PLAYLIST_ENTRY_FIELD_PARAM_NAME));
	_tmp2_ = g_strdup ((const gchar*) _tmp1_);
	result = _tmp2_;
	return result;
}


gchar* xnoise_playlist_entry_get_param_value (XnoisePlaylistEntry* self) {
	gchar* result = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_ = NULL;
	gchar* _tmp2_;
	g_return_val_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self), NULL);
	_tmp0_ = self->priv->htable;
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) XNOISE_PLAYLIST_ENTRY_FIELD_PARAM_VALUE));
	_tmp2_ = g_strdup ((const gchar*) _tmp1_);
	result = _tmp2_;
	return result;
}


glong xnoise_playlist_entry_get_duration (XnoisePlaylistEntry* self) {
	glong result = 0L;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* s;
	const gchar* _tmp3_;
	glong _tmp4_ = 0L;
	g_return_val_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self), 0L);
	_tmp0_ = self->priv->htable;
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) XNOISE_PLAYLIST_ENTRY_FIELD_DURATION));
	_tmp2_ = g_strdup ((const gchar*) _tmp1_);
	s = _tmp2_;
	_tmp3_ = s;
	if (_tmp3_ == NULL) {
		result = (glong) (-1);
		_g_free0 (s);
		return result;
	}
	_tmp4_ = xnoise_playlist_get_duration_from_string (&s);
	result = _tmp4_;
	_g_free0 (s);
	return result;
}


gboolean xnoise_playlist_entry_is_remote (XnoisePlaylistEntry* self) {
	gboolean result = FALSE;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* s;
	const gchar* _tmp3_;
	g_return_val_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self), FALSE);
	_tmp0_ = self->priv->htable;
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) XNOISE_PLAYLIST_ENTRY_FIELD_IS_REMOTE));
	_tmp2_ = g_strdup ((const gchar*) _tmp1_);
	s = _tmp2_;
	_tmp3_ = s;
	if (g_strcmp0 (_tmp3_, "1") == 0) {
		result = TRUE;
		_g_free0 (s);
		return result;
	}
	result = FALSE;
	_g_free0 (s);
	return result;
}


gboolean xnoise_playlist_entry_is_playlist (XnoisePlaylistEntry* self) {
	gboolean result = FALSE;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* s;
	const gchar* _tmp3_;
	g_return_val_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self), FALSE);
	_tmp0_ = self->priv->htable;
	_tmp1_ = g_hash_table_lookup (_tmp0_, (gpointer) ((gintptr) XNOISE_PLAYLIST_ENTRY_FIELD_IS_PLAYLIST));
	_tmp2_ = g_strdup ((const gchar*) _tmp1_);
	s = _tmp2_;
	_tmp3_ = s;
	if (g_strcmp0 (_tmp3_, "1") == 0) {
		result = TRUE;
		_g_free0 (s);
		return result;
	}
	result = FALSE;
	_g_free0 (s);
	return result;
}


XnoisePlaylistTargetType xnoise_playlist_entry_get_target_type (XnoisePlaylistEntry* self) {
	XnoisePlaylistTargetType result;
	XnoisePlaylistTargetType _tmp0_;
	g_return_val_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self), 0);
	_tmp0_ = self->priv->_target_type;
	result = _tmp0_;
	return result;
}


void xnoise_playlist_entry_set_target_type (XnoisePlaylistEntry* self, XnoisePlaylistTargetType value) {
	XnoisePlaylistTargetType _tmp0_;
	g_return_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self));
	_tmp0_ = value;
	self->priv->_target_type = _tmp0_;
}


const gchar* xnoise_playlist_entry_get_base_path (XnoisePlaylistEntry* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self), NULL);
	_tmp0_ = self->priv->_base_path;
	result = _tmp0_;
	return result;
}


void xnoise_playlist_entry_set_base_path (XnoisePlaylistEntry* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (XNOISE_PLAYLIST_IS_ENTRY (self));
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_base_path);
	self->priv->_base_path = _tmp1_;
}


static void xnoise_playlist_value_entry_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void xnoise_playlist_value_entry_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		xnoise_playlist_entry_unref (value->data[0].v_pointer);
	}
}


static void xnoise_playlist_value_entry_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = xnoise_playlist_entry_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer xnoise_playlist_value_entry_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* xnoise_playlist_value_entry_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		XnoisePlaylistEntry* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = xnoise_playlist_entry_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* xnoise_playlist_value_entry_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	XnoisePlaylistEntry** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = xnoise_playlist_entry_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* xnoise_playlist_param_spec_entry (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	XnoisePlaylistParamSpecEntry* spec;
	g_return_val_if_fail (g_type_is_a (object_type, XNOISE_PLAYLIST_TYPE_ENTRY), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer xnoise_playlist_value_get_entry (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, XNOISE_PLAYLIST_TYPE_ENTRY), NULL);
	return value->data[0].v_pointer;
}


void xnoise_playlist_value_set_entry (GValue* value, gpointer v_object) {
	XnoisePlaylistEntry* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, XNOISE_PLAYLIST_TYPE_ENTRY));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, XNOISE_PLAYLIST_TYPE_ENTRY));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		xnoise_playlist_entry_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		xnoise_playlist_entry_unref (old);
	}
}


void xnoise_playlist_value_take_entry (GValue* value, gpointer v_object) {
	XnoisePlaylistEntry* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, XNOISE_PLAYLIST_TYPE_ENTRY));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, XNOISE_PLAYLIST_TYPE_ENTRY));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		xnoise_playlist_entry_unref (old);
	}
}


static void xnoise_playlist_entry_class_init (XnoisePlaylistEntryClass * klass) {
	xnoise_playlist_entry_parent_class = g_type_class_peek_parent (klass);
	XNOISE_PLAYLIST_ENTRY_CLASS (klass)->finalize = xnoise_playlist_entry_finalize;
	g_type_class_add_private (klass, sizeof (XnoisePlaylistEntryPrivate));
}


static void xnoise_playlist_entry_instance_init (XnoisePlaylistEntry * self) {
	self->priv = XNOISE_PLAYLIST_ENTRY_GET_PRIVATE (self);
	self->priv->htable = NULL;
	self->priv->_target_type = XNOISE_PLAYLIST_TARGET_TYPE_URI;
	self->priv->_base_path = NULL;
	self->ref_count = 1;
}


static void xnoise_playlist_entry_finalize (XnoisePlaylistEntry* obj) {
	XnoisePlaylistEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, XNOISE_PLAYLIST_TYPE_ENTRY, XnoisePlaylistEntry);
	_g_hash_table_unref0 (self->priv->htable);
	self->priv->htable = NULL;
	_g_hash_table_unref0 (self->priv->htable);
	_g_free0 (self->priv->_base_path);
}


GType xnoise_playlist_entry_get_type (void) {
	static volatile gsize xnoise_playlist_entry_type_id__volatile = 0;
	if (g_once_init_enter (&xnoise_playlist_entry_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { xnoise_playlist_value_entry_init, xnoise_playlist_value_entry_free_value, xnoise_playlist_value_entry_copy_value, xnoise_playlist_value_entry_peek_pointer, "p", xnoise_playlist_value_entry_collect_value, "p", xnoise_playlist_value_entry_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (XnoisePlaylistEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnoise_playlist_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnoisePlaylistEntry), 0, (GInstanceInitFunc) xnoise_playlist_entry_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType xnoise_playlist_entry_type_id;
		xnoise_playlist_entry_type_id = g_type_register_fundamental (g_type_fundamental_next (), "XnoisePlaylistEntry", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&xnoise_playlist_entry_type_id__volatile, xnoise_playlist_entry_type_id);
	}
	return xnoise_playlist_entry_type_id__volatile;
}


gpointer xnoise_playlist_entry_ref (gpointer instance) {
	XnoisePlaylistEntry* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void xnoise_playlist_entry_unref (gpointer instance) {
	XnoisePlaylistEntry* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		XNOISE_PLAYLIST_ENTRY_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



