/* magnatune-db-conv.c generated by valac, the Vala compiler
 * generated from magnatune-db-conv.vala, do not modify */

/* magnatune-db-reader.vala
 *
 * Copyright (C) 2012  Jörn Magens
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The Xnoise authors hereby grant permission for non-GPL compatible
 *  GStreamer plugins to be used and distributed together with GStreamer
 *  and Xnoise. This permission is above and beyond the permissions granted
 *  by the GPL license by which Xnoise is covered. If you modify this code
 *  you may extend this exception to your version of the code, but you are not
 *  obligated to do so. If you do not wish to do so, delete this exception
 *  statement from your version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author:
 *     Jörn Magens
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <sqlite3.h>
#include <gio/gio.h>
#include <xnoise-1.0.h>
#include <stdio.h>


#define TYPE_MAGNATUNE_DATABASE_CONVERTER (magnatune_database_converter_get_type ())
#define MAGNATUNE_DATABASE_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAGNATUNE_DATABASE_CONVERTER, MagnatuneDatabaseConverter))
#define MAGNATUNE_DATABASE_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAGNATUNE_DATABASE_CONVERTER, MagnatuneDatabaseConverterClass))
#define IS_MAGNATUNE_DATABASE_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAGNATUNE_DATABASE_CONVERTER))
#define IS_MAGNATUNE_DATABASE_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAGNATUNE_DATABASE_CONVERTER))
#define MAGNATUNE_DATABASE_CONVERTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAGNATUNE_DATABASE_CONVERTER, MagnatuneDatabaseConverterClass))

typedef struct _MagnatuneDatabaseConverter MagnatuneDatabaseConverter;
typedef struct _MagnatuneDatabaseConverterClass MagnatuneDatabaseConverterClass;
typedef struct _MagnatuneDatabaseConverterPrivate MagnatuneDatabaseConverterPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define __vala_XnoiseItem_free0(var) ((var == NULL) ? NULL : (var = (_vala_XnoiseItem_free (var), NULL)))
typedef struct _Block10Data Block10Data;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MagnatuneDatabaseConverter {
	GObject parent_instance;
	MagnatuneDatabaseConverterPrivate * priv;
};

struct _MagnatuneDatabaseConverterClass {
	GObjectClass parent_class;
};

struct _MagnatuneDatabaseConverterPrivate {
	gchar* DATABASE;
	sqlite3_stmt* begin_statement;
	sqlite3_stmt* commit_statement;
	sqlite3_stmt* get_artist_id_statement;
	sqlite3_stmt* insert_artist_statement;
	sqlite3_stmt* get_album_id_statement;
	sqlite3_stmt* insert_album_statement;
	sqlite3_stmt* get_uri_id_statement;
	sqlite3_stmt* insert_uri_statement;
	sqlite3_stmt* get_genre_id_statement;
	sqlite3_stmt* insert_genre_statement;
	sqlite3_stmt* insert_title_statement;
	sqlite3_stmt* get_title_id_statement;
	GCancellable* cancel;
	gboolean begin_stmt_used;
	gint count;
	sqlite3* source;
	sqlite3* target;
};

struct _Block10Data {
	int _ref_count_;
	MagnatuneDatabaseConverter * self;
	gint cz;
};


static gpointer magnatune_database_converter_parent_class = NULL;
extern gchar* CONVERTED_DB;
static GType magnatune_database_converter_type_id = 0;

GType magnatune_database_converter_get_type (void) G_GNUC_CONST;
GType magnatune_database_converter_register_type (GTypeModule * module);
#define MAGNATUNE_DATABASE_CONVERTER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MAGNATUNE_DATABASE_CONVERTER, MagnatuneDatabaseConverterPrivate))
enum  {
	MAGNATUNE_DATABASE_CONVERTER_DUMMY_PROPERTY
};
#define MAGNATUNE_DATABASE_CONVERTER_STMT_CREATE_ARTISTS "CREATE TABLE artists (id INTEGER PRIMARY KEY, name TEXT);"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_CREATE_ALBUMS "CREATE TABLE albums (id INTEGER PRIMARY KEY, artist INTEGER, name TEXT" \
", image TEXT, sku TEXT);"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_CREATE_URIS "CREATE TABLE uris (id INTEGER PRIMARY KEY, name TEXT, type INTEGER, tr" \
"ansformed TEXT);"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_CREATE_GENRES "CREATE TABLE genres (id integer primary key, name TEXT);"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_CREATE_ITEMS "CREATE TABLE items (id INTEGER PRIMARY KEY, tracknumber INTEGER, artis" \
"t INTEGER, album INTEGER, title TEXT, genre INTEGER, year INTEGER, uri" \
" INTEGER, mediatype INTEGER, length INTEGER, bitrate INTEGER, usertags" \
" TEXT, playcount INTEGER, rating INTEGER, lastplayTime DATETIME, addTi" \
"meUnix INTEGER, mimetype TEXT);"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_BEGIN "BEGIN"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_COMMIT "COMMIT"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_CHECK_TRACK_EXISTS "SELECT t.id FROM items t, uris u WHERE t.uri = u.id AND u.name = ?"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_INSERT_ARTIST "INSERT INTO artists (name) VALUES (?)"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_INSERT_ALBUM "INSERT INTO albums (artist, name, sku) VALUES (?, ?, ?)"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_GET_URI_ID "SELECT id FROM uris WHERE name = ?"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_INSERT_URI "INSERT INTO uris (name) VALUES (?)"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_GET_GENRE_ID "SELECT id FROM genres WHERE utf8_lower(name) = ?"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_INSERT_GENRE "INSERT INTO genres (name) VALUES (?)"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_GET_TITLE_ID "SELECT id FROM items WHERE artist = ? AND album = ? AND utf8_lower(tit" \
"le) = ?"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_GET_TRACKS "SELECT DISTINCT s.desc, s.mp3, s.number, al.artist, s.albumname, g.gen" \
"re, al.launchdate, s.duration, al.sku FROM albums al, songs s, genres " \
"g WHERE s.albumname = al.albumname AND g.albumname = al.albumname"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_GET_GET_ITEM_ID "SELECT id FROM items WHERE artist = ? AND album = ? AND title = ?"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_INSERT_TITLE "INSERT INTO items (tracknumber, artist, album, title, genre, year, uri" \
", mediatype, length, bitrate, mimetype) VALUES (?, ?, ?, ?, ?, ?, ?, ?" \
", ?, ?, ?)"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_GET_ITEM_ID "SELECT t.id FROM items t, uris u WHERE t.uri = u.id AND u.id = ?"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_GET_ARTIST_MAX_ID "SELECT MAX(id) FROM artists"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_GET_ARTIST_ID "SELECT id FROM artists WHERE utf8_lower(name) = ?"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_UPDATE_ARTIST_NAME "UPDATE artists SET name=? WHERE id=?"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_INS_ALBUM "INSERT INTO albums (artist, name, sku) VALUES ((SELECT id FROM artists" \
" ar WHERE utf8_lower(ar.name) = ?), ?)"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_GET_ALBUM_ID "SELECT id FROM albums WHERE artist = ? AND utf8_lower(name) = ?"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_GET_ALBUMS_MAX_ID "SELECT MAX(id) FROM albums"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_GET_URI_MAX_ID "SELECT MAX(id) FROM uris"
#define MAGNATUNE_DATABASE_CONVERTER_STMT_GET_GENRE_MAX_ID "SELECT MAX(id) FROM genres"
MagnatuneDatabaseConverter* magnatune_database_converter_new (GCancellable* cancel);
MagnatuneDatabaseConverter* magnatune_database_converter_construct (GType object_type, GCancellable* cancel);
static gchar* magnatune_database_converter_dbFileName (MagnatuneDatabaseConverter* self);
static gboolean magnatune_database_converter_create_target_db (MagnatuneDatabaseConverter* self);
static void magnatune_database_converter_prepare_target_statements (MagnatuneDatabaseConverter* self);
static void magnatune_database_converter_utf8_lower (sqlite3_context* context, int values_length1, sqlite3_value** values);
static void _magnatune_database_converter_utf8_lower_sqlite_user_func_callback (sqlite3_context* context, int values_length1, sqlite3_value** values);
void magnatune_database_converter_move_data (MagnatuneDatabaseConverter* self);
void magnatune_database_converter_begin_transaction (MagnatuneDatabaseConverter* self);
static void magnatune_database_converter_get_source_tracks (MagnatuneDatabaseConverter* self);
void magnatune_database_converter_commit_transaction (MagnatuneDatabaseConverter* self);
static gboolean magnatune_database_converter_exec_prepared_stmt (MagnatuneDatabaseConverter* self, sqlite3_stmt* stmt);
static void magnatune_database_converter_db_error (MagnatuneDatabaseConverter* self, sqlite3** x);
static XnoiseItem* _xnoise_item_dup (XnoiseItem* self);
static gint magnatune_database_converter_handle_artist (MagnatuneDatabaseConverter* self, gchar** artist, gboolean update_artist);
static void _vala_XnoiseItem_free (XnoiseItem* self);
static gint magnatune_database_converter_handle_album (MagnatuneDatabaseConverter* self, gint* artist_id, gchar** album, gchar** sku);
static gint magnatune_database_converter_handle_uri (MagnatuneDatabaseConverter* self, const gchar* uri);
static gint magnatune_database_converter_handle_genre (MagnatuneDatabaseConverter* self, gchar** genre);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static gboolean ____lambda30_ (Block10Data* _data10_);
static gboolean _____lambda30__gsource_func (gpointer self);
static gboolean __lambda31_ (MagnatuneDatabaseConverter* self);
static gboolean ___lambda31__gsource_func (gpointer self);
static void magnatune_database_converter_setup_target_handle (MagnatuneDatabaseConverter* self);
static gboolean magnatune_database_converter_exec_stmnt_string (MagnatuneDatabaseConverter* self, const gchar* statement);
#define UNZIPPED_DB "/tmp/xnoise_magnatune_db"
static void magnatune_database_converter_finalize (GObject* obj);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


MagnatuneDatabaseConverter* magnatune_database_converter_construct (GType object_type, GCancellable* cancel) {
	MagnatuneDatabaseConverter * self = NULL;
	GCancellable* _tmp0_;
	GCancellable* _tmp1_;
	const gchar* _tmp2_;
	GFile* _tmp3_ = NULL;
	GFile* ft;
	GFile* _tmp4_;
	GCancellable* _tmp5_;
	gboolean _tmp6_ = FALSE;
	GFile* _tmp11_;
	GCancellable* _tmp12_;
	gboolean _tmp13_ = FALSE;
	gchar* _tmp14_ = NULL;
	const gchar* _tmp15_;
	sqlite3* _tmp16_ = NULL;
	gint _tmp17_ = 0;
	sqlite3* _tmp19_;
	GCancellable* _tmp20_;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean ret;
	gboolean _tmp23_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (G_IS_CANCELLABLE (cancel), NULL);
	self = (MagnatuneDatabaseConverter*) g_object_new (object_type, NULL);
	_tmp0_ = cancel;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->cancel);
	self->priv->cancel = _tmp1_;
	_tmp2_ = CONVERTED_DB;
	_tmp3_ = g_file_new_for_path (_tmp2_);
	ft = _tmp3_;
	_tmp4_ = ft;
	_tmp5_ = cancel;
	_tmp6_ = g_file_query_exists (_tmp4_, _tmp5_);
	if (_tmp6_) {
		{
			GFile* _tmp7_;
			GCancellable* _tmp8_;
			_tmp7_ = ft;
			_tmp8_ = cancel;
			g_file_delete (_tmp7_, _tmp8_, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch26_g_error;
			}
		}
		goto __finally26;
		__catch26_g_error:
		{
			GError* e = NULL;
			GError* _tmp9_;
			const gchar* _tmp10_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp9_ = e;
			_tmp10_ = _tmp9_->message;
			g_print ("##1%s\n", _tmp10_);
			_g_error_free0 (e);
		}
		__finally26:
		if (_inner_error_ != NULL) {
			_g_object_unref0 (ft);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp11_ = ft;
	_tmp12_ = cancel;
	_tmp13_ = g_file_query_exists (_tmp11_, _tmp12_);
	if (_tmp13_) {
		g_printerr ("target file is still there\n");
	}
	_tmp14_ = magnatune_database_converter_dbFileName (self);
	_g_free0 (self->priv->DATABASE);
	self->priv->DATABASE = _tmp14_;
	_sqlite3_close0 (self->priv->source);
	self->priv->source = NULL;
	_tmp15_ = self->priv->DATABASE;
	_tmp17_ = sqlite3_open_v2 (_tmp15_, &_tmp16_, SQLITE_OPEN_READONLY, NULL);
	_sqlite3_close0 (self->priv->source);
	self->priv->source = _tmp16_;
	if (_tmp17_ != SQLITE_OK) {
		sqlite3* _tmp18_;
		_tmp18_ = self->priv->source;
		g_error ("magnatune-db-conv.vala:104: Can't open magnatune database: %s\n", (const gchar*) sqlite3_errmsg);
	}
	_tmp19_ = self->priv->source;
	if (_tmp19_ == NULL) {
		g_error ("magnatune-db-conv.vala:107: magnatune db failed");
	}
	_tmp20_ = cancel;
	_tmp21_ = g_cancellable_is_cancelled (_tmp20_);
	if (_tmp21_) {
		_g_object_unref0 (ft);
		return self;
	}
	_tmp22_ = magnatune_database_converter_create_target_db (self);
	ret = _tmp22_;
	_tmp23_ = ret;
	_vala_assert (_tmp23_ == TRUE, "ret == true");
	magnatune_database_converter_prepare_target_statements (self);
	_g_object_unref0 (ft);
	return self;
}


MagnatuneDatabaseConverter* magnatune_database_converter_new (GCancellable* cancel) {
	return magnatune_database_converter_construct (TYPE_MAGNATUNE_DATABASE_CONVERTER, cancel);
}


static void _magnatune_database_converter_utf8_lower_sqlite_user_func_callback (sqlite3_context* context, int values_length1, sqlite3_value** values) {
	magnatune_database_converter_utf8_lower (context, values_length1, values);
}


static void magnatune_database_converter_prepare_target_statements (MagnatuneDatabaseConverter* self) {
	sqlite3* _tmp0_;
	sqlite3* _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	sqlite3* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	sqlite3* _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	sqlite3* _tmp7_;
	sqlite3_stmt* _tmp8_ = NULL;
	sqlite3* _tmp9_;
	sqlite3_stmt* _tmp10_ = NULL;
	sqlite3* _tmp11_;
	sqlite3_stmt* _tmp12_ = NULL;
	sqlite3* _tmp13_;
	sqlite3_stmt* _tmp14_ = NULL;
	sqlite3* _tmp15_;
	sqlite3_stmt* _tmp16_ = NULL;
	sqlite3* _tmp17_;
	sqlite3_stmt* _tmp18_ = NULL;
	sqlite3* _tmp19_;
	sqlite3_stmt* _tmp20_ = NULL;
	sqlite3* _tmp21_;
	sqlite3_stmt* _tmp22_ = NULL;
	sqlite3* _tmp23_;
	sqlite3_stmt* _tmp24_ = NULL;
	g_return_if_fail (IS_MAGNATUNE_DATABASE_CONVERTER (self));
	_tmp0_ = self->priv->target;
	sqlite3_create_function_v2 (_tmp0_, "utf8_lower", 1, SQLITE_ANY, NULL, _magnatune_database_converter_utf8_lower_sqlite_user_func_callback, NULL, NULL, NULL);
	_tmp1_ = self->priv->target;
	sqlite3_prepare_v2 (_tmp1_, MAGNATUNE_DATABASE_CONVERTER_STMT_BEGIN, -1, &_tmp2_, NULL);
	_sqlite3_finalize0 (self->priv->begin_statement);
	self->priv->begin_statement = _tmp2_;
	_tmp3_ = self->priv->target;
	sqlite3_prepare_v2 (_tmp3_, MAGNATUNE_DATABASE_CONVERTER_STMT_COMMIT, -1, &_tmp4_, NULL);
	_sqlite3_finalize0 (self->priv->commit_statement);
	self->priv->commit_statement = _tmp4_;
	_tmp5_ = self->priv->target;
	sqlite3_prepare_v2 (_tmp5_, MAGNATUNE_DATABASE_CONVERTER_STMT_GET_ARTIST_ID, -1, &_tmp6_, NULL);
	_sqlite3_finalize0 (self->priv->get_artist_id_statement);
	self->priv->get_artist_id_statement = _tmp6_;
	_tmp7_ = self->priv->target;
	sqlite3_prepare_v2 (_tmp7_, MAGNATUNE_DATABASE_CONVERTER_STMT_INSERT_ARTIST, -1, &_tmp8_, NULL);
	_sqlite3_finalize0 (self->priv->insert_artist_statement);
	self->priv->insert_artist_statement = _tmp8_;
	_tmp9_ = self->priv->target;
	sqlite3_prepare_v2 (_tmp9_, MAGNATUNE_DATABASE_CONVERTER_STMT_GET_ALBUM_ID, -1, &_tmp10_, NULL);
	_sqlite3_finalize0 (self->priv->get_album_id_statement);
	self->priv->get_album_id_statement = _tmp10_;
	_tmp11_ = self->priv->target;
	sqlite3_prepare_v2 (_tmp11_, MAGNATUNE_DATABASE_CONVERTER_STMT_INSERT_ALBUM, -1, &_tmp12_, NULL);
	_sqlite3_finalize0 (self->priv->insert_album_statement);
	self->priv->insert_album_statement = _tmp12_;
	_tmp13_ = self->priv->target;
	sqlite3_prepare_v2 (_tmp13_, MAGNATUNE_DATABASE_CONVERTER_STMT_GET_URI_ID, -1, &_tmp14_, NULL);
	_sqlite3_finalize0 (self->priv->get_uri_id_statement);
	self->priv->get_uri_id_statement = _tmp14_;
	_tmp15_ = self->priv->target;
	sqlite3_prepare_v2 (_tmp15_, MAGNATUNE_DATABASE_CONVERTER_STMT_INSERT_URI, -1, &_tmp16_, NULL);
	_sqlite3_finalize0 (self->priv->insert_uri_statement);
	self->priv->insert_uri_statement = _tmp16_;
	_tmp17_ = self->priv->target;
	sqlite3_prepare_v2 (_tmp17_, MAGNATUNE_DATABASE_CONVERTER_STMT_GET_GENRE_ID, -1, &_tmp18_, NULL);
	_sqlite3_finalize0 (self->priv->get_genre_id_statement);
	self->priv->get_genre_id_statement = _tmp18_;
	_tmp19_ = self->priv->target;
	sqlite3_prepare_v2 (_tmp19_, MAGNATUNE_DATABASE_CONVERTER_STMT_INSERT_GENRE, -1, &_tmp20_, NULL);
	_sqlite3_finalize0 (self->priv->insert_genre_statement);
	self->priv->insert_genre_statement = _tmp20_;
	_tmp21_ = self->priv->target;
	sqlite3_prepare_v2 (_tmp21_, MAGNATUNE_DATABASE_CONVERTER_STMT_INSERT_TITLE, -1, &_tmp22_, NULL);
	_sqlite3_finalize0 (self->priv->insert_title_statement);
	self->priv->insert_title_statement = _tmp22_;
	_tmp23_ = self->priv->target;
	sqlite3_prepare_v2 (_tmp23_, MAGNATUNE_DATABASE_CONVERTER_STMT_GET_TITLE_ID, -1, &_tmp24_, NULL);
	_sqlite3_finalize0 (self->priv->get_title_id_statement);
	self->priv->get_title_id_statement = _tmp24_;
}


void magnatune_database_converter_move_data (MagnatuneDatabaseConverter* self) {
	g_return_if_fail (IS_MAGNATUNE_DATABASE_CONVERTER (self));
	magnatune_database_converter_begin_transaction (self);
	magnatune_database_converter_get_source_tracks (self);
	magnatune_database_converter_commit_transaction (self);
	return;
}


void magnatune_database_converter_begin_transaction (MagnatuneDatabaseConverter* self) {
	sqlite3_stmt* _tmp0_;
	g_return_if_fail (IS_MAGNATUNE_DATABASE_CONVERTER (self));
	_tmp0_ = self->priv->begin_statement;
	magnatune_database_converter_exec_prepared_stmt (self, _tmp0_);
	self->priv->begin_stmt_used = TRUE;
}


void magnatune_database_converter_commit_transaction (MagnatuneDatabaseConverter* self) {
	gboolean _tmp0_;
	sqlite3_stmt* _tmp1_;
	g_return_if_fail (IS_MAGNATUNE_DATABASE_CONVERTER (self));
	_tmp0_ = self->priv->begin_stmt_used;
	if (_tmp0_ != TRUE) {
		return;
	}
	_tmp1_ = self->priv->commit_statement;
	magnatune_database_converter_exec_prepared_stmt (self, _tmp1_);
	self->priv->begin_stmt_used = FALSE;
}


static gboolean magnatune_database_converter_exec_prepared_stmt (MagnatuneDatabaseConverter* self, sqlite3_stmt* stmt) {
	gboolean result = FALSE;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	gint _tmp2_ = 0;
	g_return_val_if_fail (IS_MAGNATUNE_DATABASE_CONVERTER (self), FALSE);
	g_return_val_if_fail (stmt != NULL, FALSE);
	_tmp0_ = stmt;
	sqlite3_reset (_tmp0_);
	_tmp1_ = stmt;
	_tmp2_ = sqlite3_step (_tmp1_);
	if (_tmp2_ != SQLITE_DONE) {
		magnatune_database_converter_db_error (self, &self->priv->target);
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}


static XnoiseItem* _xnoise_item_dup (XnoiseItem* self) {
	XnoiseItem* dup;
	dup = g_new0 (XnoiseItem, 1);
	xnoise_item_copy (self, dup);
	return dup;
}


static gpointer __xnoise_item_dup0 (gpointer self) {
	return self ? _xnoise_item_dup (self) : NULL;
}


static void _vala_XnoiseItem_free (XnoiseItem* self) {
	xnoise_item_destroy (self);
	g_free (self);
}


static Block10Data* block10_data_ref (Block10Data* _data10_) {
	g_atomic_int_inc (&_data10_->_ref_count_);
	return _data10_;
}


static void block10_data_unref (void * _userdata_) {
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
		MagnatuneDatabaseConverter * self;
		self = _data10_->self;
		_g_object_unref0 (self);
		g_slice_free (Block10Data, _data10_);
	}
}


static gboolean ____lambda30_ (Block10Data* _data10_) {
	MagnatuneDatabaseConverter * self;
	gboolean result = FALSE;
	gint _tmp0_;
	self = _data10_->self;
	_tmp0_ = _data10_->cz;
	g_signal_emit_by_name (self, "progress", _tmp0_);
	result = FALSE;
	return result;
}


static gboolean _____lambda30__gsource_func (gpointer self) {
	gboolean result;
	result = ____lambda30_ (self);
	return result;
}


static gboolean __lambda31_ (MagnatuneDatabaseConverter* self) {
	gboolean result = FALSE;
	GCancellable* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gint _tmp2_;
	_tmp0_ = self->priv->cancel;
	_tmp1_ = g_cancellable_is_cancelled (_tmp0_);
	if (_tmp1_) {
		result = FALSE;
		return result;
	}
	_tmp2_ = self->priv->count;
	g_signal_emit_by_name (self, "progress", _tmp2_);
	result = FALSE;
	return result;
}


static gboolean ___lambda31__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda31_ (self);
	return result;
}


static void magnatune_database_converter_get_source_tracks (MagnatuneDatabaseConverter* self) {
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	g_return_if_fail (IS_MAGNATUNE_DATABASE_CONVERTER (self));
	_tmp0_ = self->priv->source;
	sqlite3_prepare_v2 (_tmp0_, MAGNATUNE_DATABASE_CONVERTER_STMT_GET_TRACKS, -1, &_tmp1_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp1_;
	self->priv->count = 0;
	while (TRUE) {
		sqlite3_stmt* _tmp2_;
		gint _tmp3_ = 0;
		GCancellable* _tmp4_;
		gboolean _tmp5_ = FALSE;
		XnoiseItem _tmp6_ = {0};
		XnoiseItem _tmp7_;
		XnoiseItem* _tmp8_;
		XnoiseItem* _tmp9_;
		XnoiseItem* i;
		XnoiseItem* _tmp10_;
		sqlite3_stmt* _tmp11_;
		const gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_;
		gchar* _tmp15_;
		XnoiseItem* _tmp16_;
		sqlite3_stmt* _tmp17_;
		const gchar* _tmp18_ = NULL;
		gchar* _tmp19_;
		sqlite3_stmt* _tmp20_;
		const gchar* _tmp21_ = NULL;
		gchar* _tmp22_;
		gchar* artist;
		sqlite3_stmt* _tmp23_;
		const gchar* _tmp24_ = NULL;
		gchar* _tmp25_;
		gchar* album;
		sqlite3_stmt* _tmp26_;
		const gchar* _tmp27_ = NULL;
		gchar* _tmp28_;
		gchar* genre;
		sqlite3_stmt* _tmp29_;
		const gchar* _tmp30_ = NULL;
		gchar* _tmp31_;
		gchar* sku;
		gint year;
		sqlite3_stmt* _tmp32_;
		gint _tmp33_ = 0;
		gint length;
		sqlite3_stmt* _tmp39_;
		gint _tmp40_ = 0;
		gint _tmp43_ = 0;
		gint32 artist_id;
		gint32 _tmp44_;
		gint _tmp48_ = 0;
		gint32 album_id;
		gint32 _tmp49_;
		XnoiseItem* _tmp53_;
		const gchar* _tmp54_;
		gint _tmp55_ = 0;
		gint uri_id;
		gint _tmp56_;
		gint _tmp57_ = 0;
		gint genre_id;
		gint _tmp58_;
		sqlite3_stmt* _tmp62_;
		gboolean _tmp63_ = FALSE;
		gboolean _tmp64_ = FALSE;
		gboolean _tmp65_ = FALSE;
		gboolean _tmp66_ = FALSE;
		gboolean _tmp67_ = FALSE;
		gboolean _tmp68_ = FALSE;
		gboolean _tmp69_ = FALSE;
		gboolean _tmp70_ = FALSE;
		sqlite3_stmt* _tmp71_;
		sqlite3_stmt* _tmp72_;
		gint _tmp73_ = 0;
		gint _tmp74_ = 0;
		gboolean _tmp78_;
		gboolean _tmp82_;
		gboolean _tmp89_;
		gboolean _tmp93_;
		gboolean _tmp97_;
		gboolean _tmp101_;
		gboolean _tmp106_;
		gboolean _tmp110_;
		sqlite3_stmt* _tmp111_;
		gint _tmp112_ = 0;
		gint _tmp113_;
		gint _tmp114_;
		_tmp2_ = stmt;
		_tmp3_ = sqlite3_step (_tmp2_);
		if (!(_tmp3_ == SQLITE_ROW)) {
			break;
		}
		_tmp4_ = self->priv->cancel;
		_tmp5_ = g_cancellable_is_cancelled (_tmp4_);
		if (_tmp5_) {
			_sqlite3_finalize0 (stmt);
			return;
		}
		xnoise_item_init (&_tmp6_, XNOISE_ITEM_TYPE_STREAM, NULL, (gint32) (-1));
		_tmp7_ = _tmp6_;
		_tmp8_ = __xnoise_item_dup0 (&_tmp7_);
		_tmp9_ = _tmp8_;
		xnoise_item_destroy (&_tmp7_);
		i = _tmp9_;
		_tmp10_ = i;
		_tmp11_ = stmt;
		_tmp12_ = sqlite3_column_text (_tmp11_, 1);
		_tmp13_ = g_uri_escape_string (_tmp12_, NULL, TRUE);
		_tmp14_ = _tmp13_;
		_tmp15_ = g_strconcat ("http://he3.magnatune.com/all/", _tmp14_, NULL);
		_g_free0 ((*_tmp10_).uri);
		(*_tmp10_).uri = _tmp15_;
		_g_free0 (_tmp14_);
		_tmp16_ = i;
		_tmp17_ = stmt;
		_tmp18_ = sqlite3_column_text (_tmp17_, 0);
		_tmp19_ = g_strdup (_tmp18_);
		_g_free0 ((*_tmp16_).text);
		(*_tmp16_).text = _tmp19_;
		_tmp20_ = stmt;
		_tmp21_ = sqlite3_column_text (_tmp20_, 3);
		_tmp22_ = g_strdup (_tmp21_);
		artist = _tmp22_;
		_tmp23_ = stmt;
		_tmp24_ = sqlite3_column_text (_tmp23_, 4);
		_tmp25_ = g_strdup (_tmp24_);
		album = _tmp25_;
		_tmp26_ = stmt;
		_tmp27_ = sqlite3_column_text (_tmp26_, 5);
		_tmp28_ = g_strdup (_tmp27_);
		genre = _tmp28_;
		_tmp29_ = stmt;
		_tmp30_ = sqlite3_column_text (_tmp29_, 8);
		_tmp31_ = g_strdup (_tmp30_);
		sku = _tmp31_;
		year = 0;
		_tmp32_ = stmt;
		_tmp33_ = sqlite3_column_int (_tmp32_, 6);
		if (_tmp33_ != 0) {
			sqlite3_stmt* _tmp34_;
			gint _tmp35_ = 0;
			GDateTime* _tmp36_;
			GDateTime* dt;
			GDateTime* _tmp37_;
			gint _tmp38_ = 0;
			_tmp34_ = stmt;
			_tmp35_ = sqlite3_column_int (_tmp34_, 6);
			_tmp36_ = g_date_time_new_from_unix_utc ((gint64) _tmp35_);
			dt = _tmp36_;
			_tmp37_ = dt;
			_tmp38_ = g_date_time_get_year (_tmp37_);
			year = _tmp38_;
			_g_date_time_unref0 (dt);
		}
		length = 0;
		_tmp39_ = stmt;
		_tmp40_ = sqlite3_column_int (_tmp39_, 7);
		if (_tmp40_ > 0) {
			sqlite3_stmt* _tmp41_;
			gint _tmp42_ = 0;
			_tmp41_ = stmt;
			_tmp42_ = sqlite3_column_int (_tmp41_, 7);
			length = _tmp42_;
		}
		_tmp43_ = magnatune_database_converter_handle_artist (self, &artist, FALSE);
		artist_id = (gint32) _tmp43_;
		_tmp44_ = artist_id;
		if (_tmp44_ == ((gint32) (-1))) {
			XnoiseItem* _tmp45_;
			const gchar* _tmp46_;
			const gchar* _tmp47_;
			_tmp45_ = i;
			_tmp46_ = (*_tmp45_).uri;
			_tmp47_ = artist;
			g_print ("Error importing artist for %s : '%s' ! \n", _tmp46_, _tmp47_);
			_g_free0 (sku);
			_g_free0 (genre);
			_g_free0 (album);
			_g_free0 (artist);
			__vala_XnoiseItem_free0 (i);
			_sqlite3_finalize0 (stmt);
			return;
		}
		_tmp48_ = magnatune_database_converter_handle_album (self, &artist_id, &album, &sku);
		album_id = (gint32) _tmp48_;
		_tmp49_ = album_id;
		if (_tmp49_ == ((gint32) (-1))) {
			XnoiseItem* _tmp50_;
			const gchar* _tmp51_;
			const gchar* _tmp52_;
			_tmp50_ = i;
			_tmp51_ = (*_tmp50_).uri;
			_tmp52_ = album;
			g_print ("Error importing album for %s : '%s' ! \n", _tmp51_, _tmp52_);
			_g_free0 (sku);
			_g_free0 (genre);
			_g_free0 (album);
			_g_free0 (artist);
			__vala_XnoiseItem_free0 (i);
			_sqlite3_finalize0 (stmt);
			return;
		}
		_tmp53_ = i;
		_tmp54_ = (*_tmp53_).uri;
		_tmp55_ = magnatune_database_converter_handle_uri (self, _tmp54_);
		uri_id = _tmp55_;
		_tmp56_ = uri_id;
		if (_tmp56_ == (-1)) {
			_g_free0 (sku);
			_g_free0 (genre);
			_g_free0 (album);
			_g_free0 (artist);
			__vala_XnoiseItem_free0 (i);
			_sqlite3_finalize0 (stmt);
			return;
		}
		_tmp57_ = magnatune_database_converter_handle_genre (self, &genre);
		genre_id = _tmp57_;
		_tmp58_ = genre_id;
		if (_tmp58_ == (-1)) {
			XnoiseItem* _tmp59_;
			const gchar* _tmp60_;
			const gchar* _tmp61_;
			_tmp59_ = i;
			_tmp60_ = (*_tmp59_).uri;
			_tmp61_ = genre;
			g_print ("Error importing genre for %s : '%s' ! \n", _tmp60_, _tmp61_);
			_g_free0 (sku);
			_g_free0 (genre);
			_g_free0 (album);
			_g_free0 (artist);
			__vala_XnoiseItem_free0 (i);
			_sqlite3_finalize0 (stmt);
			return;
		}
		_tmp62_ = self->priv->insert_title_statement;
		sqlite3_reset (_tmp62_);
		_tmp71_ = self->priv->insert_title_statement;
		_tmp72_ = stmt;
		_tmp73_ = sqlite3_column_int (_tmp72_, 2);
		_tmp74_ = sqlite3_bind_int (_tmp71_, 1, _tmp73_);
		if (_tmp74_ != SQLITE_OK) {
			_tmp70_ = TRUE;
		} else {
			sqlite3_stmt* _tmp75_;
			gint32 _tmp76_;
			gint _tmp77_ = 0;
			_tmp75_ = self->priv->insert_title_statement;
			_tmp76_ = artist_id;
			_tmp77_ = sqlite3_bind_int (_tmp75_, 2, (gint) _tmp76_);
			_tmp70_ = _tmp77_ != SQLITE_OK;
		}
		_tmp78_ = _tmp70_;
		if (_tmp78_) {
			_tmp69_ = TRUE;
		} else {
			sqlite3_stmt* _tmp79_;
			gint32 _tmp80_;
			gint _tmp81_ = 0;
			_tmp79_ = self->priv->insert_title_statement;
			_tmp80_ = album_id;
			_tmp81_ = sqlite3_bind_int (_tmp79_, 3, (gint) _tmp80_);
			_tmp69_ = _tmp81_ != SQLITE_OK;
		}
		_tmp82_ = _tmp69_;
		if (_tmp82_) {
			_tmp68_ = TRUE;
		} else {
			sqlite3_stmt* _tmp83_;
			sqlite3_stmt* _tmp84_;
			const gchar* _tmp85_ = NULL;
			gchar* _tmp86_;
			GDestroyNotify _tmp87_;
			gint _tmp88_ = 0;
			_tmp83_ = self->priv->insert_title_statement;
			_tmp84_ = stmt;
			_tmp85_ = sqlite3_column_text (_tmp84_, 0);
			_tmp86_ = g_strdup (_tmp85_);
			_tmp87_ = g_free;
			_tmp88_ = sqlite3_bind_text (_tmp83_, 4, _tmp86_, -1, _tmp87_);
			_tmp68_ = _tmp88_ != SQLITE_OK;
		}
		_tmp89_ = _tmp68_;
		if (_tmp89_) {
			_tmp67_ = TRUE;
		} else {
			sqlite3_stmt* _tmp90_;
			gint _tmp91_;
			gint _tmp92_ = 0;
			_tmp90_ = self->priv->insert_title_statement;
			_tmp91_ = genre_id;
			_tmp92_ = sqlite3_bind_int (_tmp90_, 5, _tmp91_);
			_tmp67_ = _tmp92_ != SQLITE_OK;
		}
		_tmp93_ = _tmp67_;
		if (_tmp93_) {
			_tmp66_ = TRUE;
		} else {
			sqlite3_stmt* _tmp94_;
			gint _tmp95_;
			gint _tmp96_ = 0;
			_tmp94_ = self->priv->insert_title_statement;
			_tmp95_ = year;
			_tmp96_ = sqlite3_bind_int (_tmp94_, 6, _tmp95_);
			_tmp66_ = _tmp96_ != SQLITE_OK;
		}
		_tmp97_ = _tmp66_;
		if (_tmp97_) {
			_tmp65_ = TRUE;
		} else {
			sqlite3_stmt* _tmp98_;
			gint _tmp99_;
			gint _tmp100_ = 0;
			_tmp98_ = self->priv->insert_title_statement;
			_tmp99_ = uri_id;
			_tmp100_ = sqlite3_bind_int (_tmp98_, 7, _tmp99_);
			_tmp65_ = _tmp100_ != SQLITE_OK;
		}
		_tmp101_ = _tmp65_;
		if (_tmp101_) {
			_tmp64_ = TRUE;
		} else {
			sqlite3_stmt* _tmp102_;
			XnoiseItem* _tmp103_;
			XnoiseItemType _tmp104_;
			gint _tmp105_ = 0;
			_tmp102_ = self->priv->insert_title_statement;
			_tmp103_ = i;
			_tmp104_ = (*_tmp103_).type;
			_tmp105_ = sqlite3_bind_int (_tmp102_, 8, (gint) _tmp104_);
			_tmp64_ = _tmp105_ != SQLITE_OK;
		}
		_tmp106_ = _tmp64_;
		if (_tmp106_) {
			_tmp63_ = TRUE;
		} else {
			sqlite3_stmt* _tmp107_;
			gint _tmp108_;
			gint _tmp109_ = 0;
			_tmp107_ = self->priv->insert_title_statement;
			_tmp108_ = length;
			_tmp109_ = sqlite3_bind_int (_tmp107_, 9, _tmp108_);
			_tmp63_ = _tmp109_ != SQLITE_OK;
		}
		_tmp110_ = _tmp63_;
		if (_tmp110_) {
			magnatune_database_converter_db_error (self, &self->priv->target);
			_g_free0 (sku);
			_g_free0 (genre);
			_g_free0 (album);
			_g_free0 (artist);
			__vala_XnoiseItem_free0 (i);
			_sqlite3_finalize0 (stmt);
			return;
		}
		_tmp111_ = self->priv->insert_title_statement;
		_tmp112_ = sqlite3_step (_tmp111_);
		if (_tmp112_ != SQLITE_DONE) {
			magnatune_database_converter_db_error (self, &self->priv->target);
			_g_free0 (sku);
			_g_free0 (genre);
			_g_free0 (album);
			_g_free0 (artist);
			__vala_XnoiseItem_free0 (i);
			_sqlite3_finalize0 (stmt);
			return;
		}
		_tmp113_ = self->priv->count;
		self->priv->count = _tmp113_ + 1;
		_tmp114_ = self->priv->count;
		if ((_tmp114_ % 200) == 0) {
			Block10Data* _data10_;
			gint _tmp115_;
			_data10_ = g_slice_new0 (Block10Data);
			_data10_->_ref_count_ = 1;
			_data10_->self = g_object_ref (self);
			_tmp115_ = self->priv->count;
			_data10_->cz = _tmp115_;
			g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _____lambda30__gsource_func, block10_data_ref (_data10_), block10_data_unref);
			block10_data_unref (_data10_);
			_data10_ = NULL;
		}
		_g_free0 (sku);
		_g_free0 (genre);
		_g_free0 (album);
		_g_free0 (artist);
		__vala_XnoiseItem_free0 (i);
	}
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda31__gsource_func, g_object_ref (self), g_object_unref);
	_sqlite3_finalize0 (stmt);
}


static gboolean magnatune_database_converter_create_target_db (MagnatuneDatabaseConverter* self) {
	gboolean result = FALSE;
	GCancellable* _tmp0_;
	gboolean _tmp1_ = FALSE;
	sqlite3* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	g_return_val_if_fail (IS_MAGNATUNE_DATABASE_CONVERTER (self), FALSE);
	_tmp0_ = self->priv->cancel;
	_tmp1_ = g_cancellable_is_cancelled (_tmp0_);
	if (_tmp1_) {
		result = FALSE;
		return result;
	}
	magnatune_database_converter_setup_target_handle (self);
	_tmp2_ = self->priv->target;
	if (_tmp2_ == NULL) {
		result = FALSE;
		return result;
	}
	_tmp3_ = magnatune_database_converter_exec_stmnt_string (self, MAGNATUNE_DATABASE_CONVERTER_STMT_CREATE_ARTISTS);
	if (!_tmp3_) {
		result = FALSE;
		return result;
	}
	_tmp4_ = magnatune_database_converter_exec_stmnt_string (self, MAGNATUNE_DATABASE_CONVERTER_STMT_CREATE_ALBUMS);
	if (!_tmp4_) {
		result = FALSE;
		return result;
	}
	_tmp5_ = magnatune_database_converter_exec_stmnt_string (self, MAGNATUNE_DATABASE_CONVERTER_STMT_CREATE_URIS);
	if (!_tmp5_) {
		result = FALSE;
		return result;
	}
	_tmp6_ = magnatune_database_converter_exec_stmnt_string (self, MAGNATUNE_DATABASE_CONVERTER_STMT_CREATE_ITEMS);
	if (!_tmp6_) {
		result = FALSE;
		return result;
	}
	_tmp7_ = magnatune_database_converter_exec_stmnt_string (self, MAGNATUNE_DATABASE_CONVERTER_STMT_CREATE_GENRES);
	if (!_tmp7_) {
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}


static gint _sqlite3_exec (sqlite3* self, const gchar* sql, sqlite3_callback callback, void* callback_target, gchar** errmsg) {
	gchar* _vala_errmsg = NULL;
	gint result = 0;
	const gchar* sqlite_errmsg = NULL;
	const gchar* _tmp0_;
	sqlite3_callback _tmp1_;
	void* _tmp1__target;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint ec;
	const gchar* _tmp6_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (sql != NULL, 0);
	_tmp0_ = sql;
	_tmp1_ = callback;
	_tmp1__target = callback_target;
	_tmp3_ = sqlite3_exec (self, _tmp0_, _tmp1_, _tmp1__target, (char**) (&_tmp2_));
	sqlite_errmsg = _tmp2_;
	ec = _tmp3_;
	if ((&_vala_errmsg) != NULL) {
		const gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp4_ = sqlite_errmsg;
		_tmp5_ = g_strdup (_tmp4_);
		_g_free0 (_vala_errmsg);
		_vala_errmsg = _tmp5_;
	}
	_tmp6_ = sqlite_errmsg;
	sqlite3_free ((void*) _tmp6_);
	result = ec;
	if (errmsg) {
		*errmsg = _vala_errmsg;
	} else {
		_g_free0 (_vala_errmsg);
	}
	return result;
}


static gboolean magnatune_database_converter_exec_stmnt_string (MagnatuneDatabaseConverter* self, const gchar* statement) {
	gboolean result = FALSE;
	gchar* errormsg = NULL;
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	g_return_val_if_fail (IS_MAGNATUNE_DATABASE_CONVERTER (self), FALSE);
	g_return_val_if_fail (statement != NULL, FALSE);
	_tmp0_ = self->priv->target;
	_tmp1_ = statement;
	_tmp3_ = _sqlite3_exec (_tmp0_, _tmp1_, NULL, NULL, &_tmp2_);
	_g_free0 (errormsg);
	errormsg = _tmp2_;
	if (_tmp3_ != SQLITE_OK) {
		FILE* _tmp4_;
		const gchar* _tmp5_;
		_tmp4_ = stderr;
		_tmp5_ = errormsg;
		fprintf (_tmp4_, "exec_stmnt_string error: %s", _tmp5_);
		result = FALSE;
		_g_free0 (errormsg);
		return result;
	}
	result = TRUE;
	_g_free0 (errormsg);
	return result;
}


static void magnatune_database_converter_setup_target_handle (MagnatuneDatabaseConverter* self) {
	const gchar* _tmp0_;
	GFile* _tmp1_ = NULL;
	GFile* tf;
	GFile* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GFile* _tmp7_;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_;
	sqlite3* _tmp10_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_MAGNATUNE_DATABASE_CONVERTER (self));
	_tmp0_ = CONVERTED_DB;
	_tmp1_ = g_file_new_for_path (_tmp0_);
	tf = _tmp1_;
	_tmp2_ = tf;
	_tmp3_ = g_file_query_exists (_tmp2_, NULL);
	if (_tmp3_) {
		{
			GFile* _tmp4_;
			_tmp4_ = tf;
			g_file_delete (_tmp4_, NULL, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch27_g_error;
			}
		}
		goto __finally27;
		__catch27_g_error:
		{
			GError* e = NULL;
			GError* _tmp5_;
			const gchar* _tmp6_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp5_ = e;
			_tmp6_ = _tmp5_->message;
			g_print ("##2%s\n", _tmp6_);
			_g_error_free0 (e);
		}
		__finally27:
		if (_inner_error_ != NULL) {
			_g_object_unref0 (tf);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp7_ = tf;
	_tmp8_ = g_file_get_path (_tmp7_);
	_tmp9_ = _tmp8_;
	sqlite3_open_v2 (_tmp9_, &_tmp10_, SQLITE_OPEN_CREATE | SQLITE_OPEN_READWRITE, NULL);
	_sqlite3_close0 (self->priv->target);
	self->priv->target = _tmp10_;
	_g_free0 (_tmp9_);
	_g_object_unref0 (tf);
}


static void magnatune_database_converter_utf8_lower (sqlite3_context* context, int values_length1, sqlite3_value** values) {
	sqlite3_context* _tmp0_;
	sqlite3_value** _tmp1_;
	gint _tmp1__length1;
	sqlite3_value* _tmp2_;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	GDestroyNotify _tmp5_;
	g_return_if_fail (context != NULL);
	_tmp0_ = context;
	_tmp1_ = values;
	_tmp1__length1 = values_length1;
	_tmp2_ = _tmp1_[0];
	_tmp3_ = sqlite3_value_text (_tmp2_);
	_tmp4_ = g_utf8_strdown (_tmp3_, (gssize) (-1));
	_tmp5_ = g_free;
	sqlite3_result_text (_tmp0_, _tmp4_, -1, _tmp5_);
}


static gchar* magnatune_database_converter_dbFileName (MagnatuneDatabaseConverter* self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (IS_MAGNATUNE_DATABASE_CONVERTER (self), NULL);
	_tmp0_ = g_strdup (UNZIPPED_DB);
	result = _tmp0_;
	return result;
}


static void magnatune_database_converter_db_error (MagnatuneDatabaseConverter* self, sqlite3** x) {
	sqlite3* _tmp0_;
	gint _tmp1_ = 0;
	sqlite3* _tmp2_;
	const gchar* _tmp3_ = NULL;
	g_return_if_fail (IS_MAGNATUNE_DATABASE_CONVERTER (self));
	g_return_if_fail (*x != NULL);
	_tmp0_ = *x;
	_tmp1_ = sqlite3_errcode (_tmp0_);
	_tmp2_ = *x;
	_tmp3_ = sqlite3_errmsg (_tmp2_);
	g_print ("Database error %d: %s \n\n", _tmp1_, _tmp3_);
}


static gint magnatune_database_converter_handle_artist (MagnatuneDatabaseConverter* self, gchar** artist, gboolean update_artist) {
	gint result = 0;
	sqlite3_stmt* _tmp0_;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	sqlite3_stmt* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	GDestroyNotify _tmp9_;
	gint _tmp10_ = 0;
	sqlite3_stmt* _tmp11_;
	gint _tmp12_ = 0;
	sqlite3_stmt* _tmp15_;
	sqlite3_stmt* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	GDestroyNotify _tmp19_;
	gint _tmp20_ = 0;
	sqlite3_stmt* _tmp21_;
	gint _tmp22_ = 0;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp23_;
	sqlite3_stmt* _tmp24_ = NULL;
	sqlite3_stmt* _tmp25_;
	gint _tmp26_ = 0;
	g_return_val_if_fail (IS_MAGNATUNE_DATABASE_CONVERTER (self), 0);
	g_return_val_if_fail (*artist != NULL, 0);
	_tmp0_ = self->priv->get_artist_id_statement;
	sqlite3_reset (_tmp0_);
	_tmp2_ = *artist;
	if (_tmp2_ != NULL) {
		const gchar* _tmp3_;
		gchar* _tmp4_ = NULL;
		_tmp3_ = *artist;
		_tmp4_ = g_utf8_strdown (_tmp3_, (gssize) (-1));
		_g_free0 (_tmp1_);
		_tmp1_ = _tmp4_;
	} else {
		gchar* _tmp5_;
		_tmp5_ = g_strdup (XNOISE_RESOURCES_EMPTYSTRING);
		_g_free0 (_tmp1_);
		_tmp1_ = _tmp5_;
	}
	_tmp6_ = self->priv->get_artist_id_statement;
	_tmp7_ = _tmp1_;
	_tmp8_ = g_strdup (_tmp7_);
	_tmp9_ = g_free;
	_tmp10_ = sqlite3_bind_text (_tmp6_, 1, _tmp8_, -1, _tmp9_);
	if (_tmp10_ != SQLITE_OK) {
		magnatune_database_converter_db_error (self, &self->priv->target);
		result = -1;
		_g_free0 (_tmp1_);
		return result;
	}
	_tmp11_ = self->priv->get_artist_id_statement;
	_tmp12_ = sqlite3_step (_tmp11_);
	if (_tmp12_ == SQLITE_ROW) {
		sqlite3_stmt* _tmp13_;
		gint _tmp14_ = 0;
		_tmp13_ = self->priv->get_artist_id_statement;
		_tmp14_ = sqlite3_column_int (_tmp13_, 0);
		result = _tmp14_;
		_g_free0 (_tmp1_);
		return result;
	}
	_tmp15_ = self->priv->insert_artist_statement;
	sqlite3_reset (_tmp15_);
	_tmp16_ = self->priv->insert_artist_statement;
	_tmp17_ = *artist;
	_tmp18_ = g_strdup (_tmp17_);
	_tmp19_ = g_free;
	_tmp20_ = sqlite3_bind_text (_tmp16_, 1, _tmp18_, -1, _tmp19_);
	if (_tmp20_ != SQLITE_OK) {
		magnatune_database_converter_db_error (self, &self->priv->target);
		result = -1;
		_g_free0 (_tmp1_);
		return result;
	}
	_tmp21_ = self->priv->insert_artist_statement;
	_tmp22_ = sqlite3_step (_tmp21_);
	if (_tmp22_ != SQLITE_DONE) {
		magnatune_database_converter_db_error (self, &self->priv->target);
		result = -1;
		_g_free0 (_tmp1_);
		return result;
	}
	_tmp23_ = self->priv->target;
	sqlite3_prepare_v2 (_tmp23_, MAGNATUNE_DATABASE_CONVERTER_STMT_GET_ARTIST_MAX_ID, -1, &_tmp24_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp24_;
	_tmp25_ = stmt;
	_tmp26_ = sqlite3_step (_tmp25_);
	if (_tmp26_ == SQLITE_ROW) {
		sqlite3_stmt* _tmp27_;
		gint _tmp28_ = 0;
		_tmp27_ = stmt;
		_tmp28_ = sqlite3_column_int (_tmp27_, 0);
		result = _tmp28_;
		_sqlite3_finalize0 (stmt);
		_g_free0 (_tmp1_);
		return result;
	} else {
		result = -1;
		_sqlite3_finalize0 (stmt);
		_g_free0 (_tmp1_);
		return result;
	}
	_sqlite3_finalize0 (stmt);
	_g_free0 (_tmp1_);
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


static gint magnatune_database_converter_handle_album (MagnatuneDatabaseConverter* self, gint* artist_id, gchar** album, gchar** sku) {
	gint result = 0;
	sqlite3_stmt* _tmp0_;
	gboolean _tmp1_ = FALSE;
	sqlite3_stmt* _tmp2_;
	gint _tmp3_;
	gint _tmp4_ = 0;
	gboolean _tmp17_;
	sqlite3_stmt* _tmp18_;
	gint _tmp19_ = 0;
	sqlite3_stmt* _tmp22_;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp24_ = FALSE;
	sqlite3_stmt* _tmp25_;
	gint _tmp26_;
	gint _tmp27_ = 0;
	gboolean _tmp33_;
	gboolean _tmp39_;
	sqlite3_stmt* _tmp40_;
	gint _tmp41_ = 0;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp42_;
	sqlite3_stmt* _tmp43_ = NULL;
	sqlite3_stmt* _tmp44_;
	gint _tmp45_ = 0;
	g_return_val_if_fail (IS_MAGNATUNE_DATABASE_CONVERTER (self), 0);
	g_return_val_if_fail (*album != NULL, 0);
	g_return_val_if_fail (*sku != NULL, 0);
	_tmp0_ = self->priv->get_album_id_statement;
	sqlite3_reset (_tmp0_);
	_tmp2_ = self->priv->get_album_id_statement;
	_tmp3_ = *artist_id;
	_tmp4_ = sqlite3_bind_int (_tmp2_, 1, _tmp3_);
	if (_tmp4_ != SQLITE_OK) {
		_tmp1_ = TRUE;
	} else {
		gchar* _tmp5_ = NULL;
		const gchar* _tmp6_;
		sqlite3_stmt* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		GDestroyNotify _tmp15_;
		gint _tmp16_ = 0;
		_tmp6_ = *album;
		if (_tmp6_ != NULL) {
			const gchar* _tmp7_;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_;
			gchar* _tmp10_ = NULL;
			_tmp7_ = *album;
			_tmp8_ = g_utf8_strdown (_tmp7_, (gssize) (-1));
			_tmp9_ = _tmp8_;
			_tmp10_ = string_strip (_tmp9_);
			_g_free0 (_tmp5_);
			_tmp5_ = _tmp10_;
			_g_free0 (_tmp9_);
		} else {
			gchar* _tmp11_;
			_tmp11_ = g_strdup (XNOISE_RESOURCES_EMPTYSTRING);
			_g_free0 (_tmp5_);
			_tmp5_ = _tmp11_;
		}
		_tmp12_ = self->priv->get_album_id_statement;
		_tmp13_ = _tmp5_;
		_tmp14_ = g_strdup (_tmp13_);
		_tmp15_ = g_free;
		_tmp16_ = sqlite3_bind_text (_tmp12_, 2, _tmp14_, -1, _tmp15_);
		_tmp1_ = _tmp16_ != SQLITE_OK;
		_g_free0 (_tmp5_);
	}
	_tmp17_ = _tmp1_;
	if (_tmp17_) {
		magnatune_database_converter_db_error (self, &self->priv->target);
		result = -1;
		return result;
	}
	_tmp18_ = self->priv->get_album_id_statement;
	_tmp19_ = sqlite3_step (_tmp18_);
	if (_tmp19_ == SQLITE_ROW) {
		sqlite3_stmt* _tmp20_;
		gint _tmp21_ = 0;
		_tmp20_ = self->priv->get_album_id_statement;
		_tmp21_ = sqlite3_column_int (_tmp20_, 0);
		result = _tmp21_;
		return result;
	}
	_tmp22_ = self->priv->insert_album_statement;
	sqlite3_reset (_tmp22_);
	_tmp25_ = self->priv->insert_album_statement;
	_tmp26_ = *artist_id;
	_tmp27_ = sqlite3_bind_int (_tmp25_, 1, _tmp26_);
	if (_tmp27_ != SQLITE_OK) {
		_tmp24_ = TRUE;
	} else {
		sqlite3_stmt* _tmp28_;
		const gchar* _tmp29_;
		gchar* _tmp30_;
		GDestroyNotify _tmp31_;
		gint _tmp32_ = 0;
		_tmp28_ = self->priv->insert_album_statement;
		_tmp29_ = *album;
		_tmp30_ = g_strdup (_tmp29_);
		_tmp31_ = g_free;
		_tmp32_ = sqlite3_bind_text (_tmp28_, 2, _tmp30_, -1, _tmp31_);
		_tmp24_ = _tmp32_ != SQLITE_OK;
	}
	_tmp33_ = _tmp24_;
	if (_tmp33_) {
		_tmp23_ = TRUE;
	} else {
		sqlite3_stmt* _tmp34_;
		const gchar* _tmp35_;
		gchar* _tmp36_;
		GDestroyNotify _tmp37_;
		gint _tmp38_ = 0;
		_tmp34_ = self->priv->insert_album_statement;
		_tmp35_ = *sku;
		_tmp36_ = g_strdup (_tmp35_);
		_tmp37_ = g_free;
		_tmp38_ = sqlite3_bind_text (_tmp34_, 3, _tmp36_, -1, _tmp37_);
		_tmp23_ = _tmp38_ != SQLITE_OK;
	}
	_tmp39_ = _tmp23_;
	if (_tmp39_) {
		magnatune_database_converter_db_error (self, &self->priv->target);
		result = -1;
		return result;
	}
	_tmp40_ = self->priv->insert_album_statement;
	_tmp41_ = sqlite3_step (_tmp40_);
	if (_tmp41_ != SQLITE_DONE) {
		magnatune_database_converter_db_error (self, &self->priv->target);
		result = -1;
		return result;
	}
	_tmp42_ = self->priv->target;
	sqlite3_prepare_v2 (_tmp42_, MAGNATUNE_DATABASE_CONVERTER_STMT_GET_ALBUMS_MAX_ID, -1, &_tmp43_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp43_;
	_tmp44_ = stmt;
	_tmp45_ = sqlite3_step (_tmp44_);
	if (_tmp45_ == SQLITE_ROW) {
		sqlite3_stmt* _tmp46_;
		gint _tmp47_ = 0;
		_tmp46_ = stmt;
		_tmp47_ = sqlite3_column_int (_tmp46_, 0);
		result = _tmp47_;
		_sqlite3_finalize0 (stmt);
		return result;
	} else {
		result = -1;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	_sqlite3_finalize0 (stmt);
}


static gint magnatune_database_converter_handle_uri (MagnatuneDatabaseConverter* self, const gchar* uri) {
	gint result = 0;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GDestroyNotify _tmp4_;
	gint _tmp5_ = 0;
	sqlite3_stmt* _tmp6_;
	gint _tmp7_ = 0;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp8_;
	sqlite3_stmt* _tmp9_ = NULL;
	sqlite3_stmt* _tmp10_;
	gint _tmp11_ = 0;
	g_return_val_if_fail (IS_MAGNATUNE_DATABASE_CONVERTER (self), 0);
	g_return_val_if_fail (uri != NULL, 0);
	_tmp0_ = self->priv->insert_uri_statement;
	sqlite3_reset (_tmp0_);
	_tmp1_ = self->priv->insert_uri_statement;
	_tmp2_ = uri;
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = g_free;
	_tmp5_ = sqlite3_bind_text (_tmp1_, 1, _tmp3_, -1, _tmp4_);
	if (_tmp5_ != SQLITE_OK) {
		magnatune_database_converter_db_error (self, &self->priv->target);
		result = -1;
		return result;
	}
	_tmp6_ = self->priv->insert_uri_statement;
	_tmp7_ = sqlite3_step (_tmp6_);
	if (_tmp7_ != SQLITE_DONE) {
		magnatune_database_converter_db_error (self, &self->priv->target);
		result = -1;
		return result;
	}
	_tmp8_ = self->priv->target;
	sqlite3_prepare_v2 (_tmp8_, MAGNATUNE_DATABASE_CONVERTER_STMT_GET_URI_MAX_ID, -1, &_tmp9_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp9_;
	_tmp10_ = stmt;
	_tmp11_ = sqlite3_step (_tmp10_);
	if (_tmp11_ == SQLITE_ROW) {
		sqlite3_stmt* _tmp12_;
		gint _tmp13_ = 0;
		_tmp12_ = stmt;
		_tmp13_ = sqlite3_column_int (_tmp12_, 0);
		result = _tmp13_;
		_sqlite3_finalize0 (stmt);
		return result;
	} else {
		result = -1;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	_sqlite3_finalize0 (stmt);
}


static gint magnatune_database_converter_handle_genre (MagnatuneDatabaseConverter* self, gchar** genre) {
	gint result = 0;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gboolean _tmp5_;
	sqlite3_stmt* _tmp6_;
	gchar* _tmp7_ = NULL;
	const gchar* _tmp8_;
	sqlite3_stmt* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	GDestroyNotify _tmp17_;
	gint _tmp18_ = 0;
	sqlite3_stmt* _tmp19_;
	gint _tmp20_ = 0;
	sqlite3_stmt* _tmp23_;
	sqlite3_stmt* _tmp24_;
	const gchar* _tmp25_;
	gchar* _tmp26_ = NULL;
	GDestroyNotify _tmp27_;
	gint _tmp28_ = 0;
	sqlite3_stmt* _tmp29_;
	gint _tmp30_ = 0;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp31_;
	sqlite3_stmt* _tmp32_ = NULL;
	sqlite3_stmt* _tmp33_;
	gint _tmp34_ = 0;
	g_return_val_if_fail (IS_MAGNATUNE_DATABASE_CONVERTER (self), 0);
	g_return_val_if_fail (*genre != NULL, 0);
	_tmp1_ = *genre;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		_tmp2_ = *genre;
		_tmp3_ = string_strip (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = g_strcmp0 (_tmp4_, XNOISE_RESOURCES_EMPTYSTRING) == 0;
		_g_free0 (_tmp4_);
	}
	_tmp5_ = _tmp0_;
	if (_tmp5_) {
		result = -2;
		return result;
	}
	_tmp6_ = self->priv->get_genre_id_statement;
	sqlite3_reset (_tmp6_);
	_tmp8_ = *genre;
	if (_tmp8_ != NULL) {
		const gchar* _tmp9_;
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_;
		gchar* _tmp12_ = NULL;
		_tmp9_ = *genre;
		_tmp10_ = g_utf8_strdown (_tmp9_, (gssize) (-1));
		_tmp11_ = _tmp10_;
		_tmp12_ = string_strip (_tmp11_);
		_g_free0 (_tmp7_);
		_tmp7_ = _tmp12_;
		_g_free0 (_tmp11_);
	} else {
		gchar* _tmp13_;
		_tmp13_ = g_strdup (XNOISE_RESOURCES_EMPTYSTRING);
		_g_free0 (_tmp7_);
		_tmp7_ = _tmp13_;
	}
	_tmp14_ = self->priv->get_genre_id_statement;
	_tmp15_ = _tmp7_;
	_tmp16_ = g_strdup (_tmp15_);
	_tmp17_ = g_free;
	_tmp18_ = sqlite3_bind_text (_tmp14_, 1, _tmp16_, -1, _tmp17_);
	if (_tmp18_ != SQLITE_OK) {
		magnatune_database_converter_db_error (self, &self->priv->target);
		result = -1;
		_g_free0 (_tmp7_);
		return result;
	}
	_tmp19_ = self->priv->get_genre_id_statement;
	_tmp20_ = sqlite3_step (_tmp19_);
	if (_tmp20_ == SQLITE_ROW) {
		sqlite3_stmt* _tmp21_;
		gint _tmp22_ = 0;
		_tmp21_ = self->priv->get_genre_id_statement;
		_tmp22_ = sqlite3_column_int (_tmp21_, 0);
		result = _tmp22_;
		_g_free0 (_tmp7_);
		return result;
	}
	_tmp23_ = self->priv->insert_genre_statement;
	sqlite3_reset (_tmp23_);
	_tmp24_ = self->priv->insert_genre_statement;
	_tmp25_ = *genre;
	_tmp26_ = string_strip (_tmp25_);
	_tmp27_ = g_free;
	_tmp28_ = sqlite3_bind_text (_tmp24_, 1, _tmp26_, -1, _tmp27_);
	if (_tmp28_ != SQLITE_OK) {
		magnatune_database_converter_db_error (self, &self->priv->target);
		result = -1;
		_g_free0 (_tmp7_);
		return result;
	}
	_tmp29_ = self->priv->insert_genre_statement;
	_tmp30_ = sqlite3_step (_tmp29_);
	if (_tmp30_ != SQLITE_DONE) {
		magnatune_database_converter_db_error (self, &self->priv->target);
		result = -1;
		_g_free0 (_tmp7_);
		return result;
	}
	_tmp31_ = self->priv->target;
	sqlite3_prepare_v2 (_tmp31_, MAGNATUNE_DATABASE_CONVERTER_STMT_GET_GENRE_MAX_ID, -1, &_tmp32_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp32_;
	_tmp33_ = stmt;
	_tmp34_ = sqlite3_step (_tmp33_);
	if (_tmp34_ == SQLITE_ROW) {
		sqlite3_stmt* _tmp35_;
		gint _tmp36_ = 0;
		_tmp35_ = stmt;
		_tmp36_ = sqlite3_column_int (_tmp35_, 0);
		result = _tmp36_;
		_sqlite3_finalize0 (stmt);
		_g_free0 (_tmp7_);
		return result;
	} else {
		result = -1;
		_sqlite3_finalize0 (stmt);
		_g_free0 (_tmp7_);
		return result;
	}
	_sqlite3_finalize0 (stmt);
	_g_free0 (_tmp7_);
}


static void magnatune_database_converter_class_init (MagnatuneDatabaseConverterClass * klass) {
	magnatune_database_converter_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MagnatuneDatabaseConverterPrivate));
	G_OBJECT_CLASS (klass)->finalize = magnatune_database_converter_finalize;
	g_signal_new ("progress", TYPE_MAGNATUNE_DATABASE_CONVERTER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
}


static void magnatune_database_converter_instance_init (MagnatuneDatabaseConverter * self) {
	self->priv = MAGNATUNE_DATABASE_CONVERTER_GET_PRIVATE (self);
	self->priv->begin_stmt_used = FALSE;
	self->priv->count = 0;
}


static void magnatune_database_converter_finalize (GObject* obj) {
	MagnatuneDatabaseConverter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MAGNATUNE_DATABASE_CONVERTER, MagnatuneDatabaseConverter);
	_g_free0 (self->priv->DATABASE);
	_sqlite3_finalize0 (self->priv->begin_statement);
	_sqlite3_finalize0 (self->priv->commit_statement);
	_sqlite3_finalize0 (self->priv->get_artist_id_statement);
	_sqlite3_finalize0 (self->priv->insert_artist_statement);
	_sqlite3_finalize0 (self->priv->get_album_id_statement);
	_sqlite3_finalize0 (self->priv->insert_album_statement);
	_sqlite3_finalize0 (self->priv->get_uri_id_statement);
	_sqlite3_finalize0 (self->priv->insert_uri_statement);
	_sqlite3_finalize0 (self->priv->get_genre_id_statement);
	_sqlite3_finalize0 (self->priv->insert_genre_statement);
	_sqlite3_finalize0 (self->priv->insert_title_statement);
	_sqlite3_finalize0 (self->priv->get_title_id_statement);
	_g_object_unref0 (self->priv->cancel);
	_sqlite3_close0 (self->priv->source);
	_sqlite3_close0 (self->priv->target);
	G_OBJECT_CLASS (magnatune_database_converter_parent_class)->finalize (obj);
}


GType magnatune_database_converter_get_type (void) {
	return magnatune_database_converter_type_id;
}


GType magnatune_database_converter_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (MagnatuneDatabaseConverterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) magnatune_database_converter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MagnatuneDatabaseConverter), 0, (GInstanceInitFunc) magnatune_database_converter_instance_init, NULL };
	magnatune_database_converter_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MagnatuneDatabaseConverter", &g_define_type_info, 0);
	return magnatune_database_converter_type_id;
}



